@echo off
rem This script provides the command and control utility for the
rem GigaSpaces Technologies Inc. Service Grid

setlocal
call "%~dp0\setenv.bat"
set GS_LIB=%XAP_HOME%\lib
set gsboot="%GS_LIB%\required\xap-common.jar"
if not exist %gsboot% goto systemFailure

if "%1"=="services" goto services

:interactive
title GigaSpaces Technologies Service Grid : Interactive Shell
set XAP_COMPONENT_OPTIONS=%XAP_CLI_OPTIONS%
set launchTarget=com.gigaspaces.admin.cli.GS
set cliExt=config/services/services.config
set script_classpath=%PRE_CLASSPATH%;"%GS_LIB%\platform\cli\*";%GS_JARS%;"%GS_LIB%";%SPRING_JARS%;%MEMORYXTEND_JARS%;%SERVICE_GRID_JARS%;%POST_CLASSPATH%
set COMMAND=%JAVACMD% %JAVA_OPTIONS% %XAP_COMPONENT_OPTIONS% -cp %script_classpath% %XAP_OPTIONS% %launchTarget% %cliExt% %*
goto run

:services
if %2==GSA set XAP_COMPONENT_OPTIONS=%XAP_GSA_OPTIONS%
if %2==GSC set XAP_COMPONENT_OPTIONS=%XAP_GSC_OPTIONS%
if %2==GSM set XAP_COMPONENT_OPTIONS=%XAP_GSM_OPTIONS%
if %2==LH set XAP_COMPONENT_OPTIONS=%XAP_LUS_OPTIONS%
if %2==ESM set XAP_COMPONENT_OPTIONS=%XAP_ESM_OPTIONS%
if %2==TM set XAP_COMPONENT_OPTIONS=%XAP_JTX_OPTIONS%

set launchTarget=com.gigaspaces.start.SystemBoot
set PATH=%PATH%;%GS_LIB%\platform\native
set script_classpath=%PRE_CLASSPATH%;"%XAP_HOME%";%SIGAR_JARS%;%gsboot%;"%GS_LIB%\platform\service-grid\xap-service-grid-boot.jar";%POST_CLASSPATH%
set COMMAND=%JAVACMD% %JAVA_OPTIONS% %XAP_COMPONENT_OPTIONS% -DagentId=%AGENT_ID% -DgsaServiceID=%GSA_SERVICE_ID% -DenableDynamicLocators=%ENABLE_DYNAMIC_LOCATORS% -cp %script_classpath% %XAP_OPTIONS% %launchTarget% %*
goto run

:run
echo.
echo Starting with line:
echo %COMMAND%
echo.
%COMMAND%
goto end

:systemFailure
echo "Cannot locate system jars in the expected directory structure, exiting"
goto end

:end
endlocal
set ERR=%ERRORLEVEL%
title Command Prompt
%COMSPEC% /C exit %ERR% >nul