#!/bin/bash

set -e
. `dirname $0`/../../bin/setenv.sh

export TMPDIR="/tmp"

POMS_DIR="${XAP_HOME}/tools/maven/poms"
XAP_DATAGRID_POMS_DIR="${POMS_DIR}/xap-datagrid"
XAP_POMS_DIR="${POMS_DIR}/xap"
XAP_DATAGRID_EXT_POMS_DIR="${XAP_DATAGRID_POMS_DIR}/xap-extensions"
XAP_CORE_POMS_DIR="${XAP_DATAGRID_POMS_DIR}/xap-core"
XAP_EXTENSTIONS_POMS_DIR="${XAP_POMS_DIR}/xap-extensions"

echo ""
echo ""
echo "Installing XAP jars"
echo ""
echo ""

# GigaSpaces Jars
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_POMS_DIR}/pom.xml -Dfile=${XAP_POMS_DIR}/pom.xml
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_POMS_DIR}/pom.xml -Dfile=${XAP_DATAGRID_POMS_DIR}/pom.xml

# open core modules
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_CORE_POMS_DIR}/xap-common/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-common.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_CORE_POMS_DIR}/xap-trove/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-trove.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_CORE_POMS_DIR}/xap-asm/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-asm.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_CORE_POMS_DIR}/xap-datagrid/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-datagrid.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_CORE_POMS_DIR}/xap-openspaces/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-openspaces.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-map/pom.xml -Dfile=${XAP_HOME}/lib/optional/map/xap-map.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-map-spring/pom.xml -Dfile=${XAP_HOME}/lib/optional/map/xap-map-spring.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-jms/pom.xml -Dfile=${XAP_HOME}/lib/optional/jms/xap-jms.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-jetty-8/pom.xml -Dfile=${XAP_HOME}/lib/optional/jetty/xap-jetty/xap-jetty-8.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-jetty-9/pom.xml -Dfile=${XAP_HOME}/lib/optional/jetty-9/xap-jetty/xap-jetty-9.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-spatial/pom.xml -Dfile=${XAP_HOME}/lib/optional/spatial/xap-spatial.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_DATAGRID_EXT_POMS_DIR}/xap-mongodb/pom.xml -Dfile=${XAP_HOME}/lib/optional/mongodb/xap-mongodb.jar

# close core modules
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_POMS_DIR}/xap-tools/benchmark/pom.xml -Dfile=${XAP_HOME}/lib/platform/benchmark/xap-benchmark.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-zookeeper/pom.xml -Dfile=${XAP_HOME}/lib/platform/zookeeper/xap-zookeeper.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-near-cache/pom.xml -Dfile=${XAP_HOME}/lib/optional/near-cache/xap-near-cache.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-near-cache-spring/pom.xml -Dfile=${XAP_HOME}/lib/optional/near-cache/xap-near-cache-spring.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_POMS_DIR}/xap-tools/xap-cli/pom.xml -Dfile=${XAP_HOME}/lib/platform/cli/xap-cli.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-interop/pom.xml -Dfile=${XAP_HOME}/lib/optional/interop/xap-interop.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-interop-spring/pom.xml -Dfile=${XAP_HOME}/lib/optional/interop/xap-interop-spring.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-security/pom.xml -Dfile=${XAP_HOME}/lib/optional/security/xap-security.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-service-grid-boot/pom.xml -Dfile=${XAP_HOME}/lib/platform/service-grid/xap-service-grid-boot.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-service-grid/pom.xml -Dfile=${XAP_HOME}/lib/platform/service-grid/xap-service-grid.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-admin/pom.xml -Dfile=${XAP_HOME}/lib/platform/service-grid/xap-admin.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-wan-gateway/pom.xml -Dfile=${XAP_HOME}/lib/optional/wan-gateway/xap-wan-gateway.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-wan-gateway-spring/pom.xml -Dfile=${XAP_HOME}/lib/optional/wan-gateway/xap-wan-gateway-spring.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-premium-common/pom.xml -Dfile=${XAP_HOME}/lib/required/xap-premium-common.jar

# external modules
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-mx-mapdb/pom.xml -Dfile=${XAP_HOME}/lib/optional/memoryxtend/mapdb/xap-mx-mapdb.jar
mvn install:install-file -DcreateChecksum=true -DpomFile=${XAP_EXTENSTIONS_POMS_DIR}/xap-mx-rocksdb/pom.xml -Dfile=${XAP_HOME}/lib/optional/memoryxtend/rocksdb/xap-mx-rocksdb.jar

# Build and install Xap Maven Plugin
mvn -f ${XAP_HOME}/tools/maven/xap-maven-plugin/pom.xml install -DcreateChecksum=true